/* C++ methods file: Objectivity/DB DDL version 4.0.2 */

#include "AtlasProd.h"

#if defined(_MSC_VER) && !defined(OO_DDL_TRANSLATION)
#pragma pack(push,8)
#endif
const ooTypeNumber AtlasProdEvent::opiTypeN = 2162693;
const ooTypeNumber AtlasProdTag::opiTypeN = 2162694;


/* included to define size_t */
#include <stddef.h>


extern "C" {
  void otmStealVtbls(ooTypeNumber, void *);
  int  otmAddToVTableInitList(void (*func)());
  void otmSignalInitError(char *);
  ooAssocNumber otmRegisterAssoc(const ooAssocNumber *, ooAssocNumber);
}

static void ooInitVTables();
static int ooDoFileInit();

#ifdef OO_AIX
struct ooVTableInitializer {
    int x;
    ooVTableInitializer() {
	ooDoFileInit();
    }
};
static ooVTableInitializer ooInitializer;
#else
static int ooInitializer = ooDoFileInit();
#endif
	/* create a static instance of the initializer,
	 * which causes default constructor to be called
	 * during static initialization, which causes
	 * address of following function to be added to
	 * the list of functions that must be called in
	 * order to initialize the in-memory schema!
	 */

static
int
ooDoFileInit()
{

  AtlasProdEvent::ooAssocRegister();
  AtlasProdTag::ooAssocRegister();

    return otmAddToVTableInitList(ooInitVTables);
}

inline
void *
operator new(size_t, void *ptr, ooInternalObj)
{
    return ptr;
}

static
void
ooInitVTables()
{
    ooInternalObj oo__iobj;
    if (sizeof(AtlasProdEvent) > 1000) {
	double *oo__buf =
	    new double [(sizeof(AtlasProdEvent) + sizeof(double) - 1)/sizeof(double)];
	if (oo__buf != 0) {
	    ooCPtr(AtlasProdEvent) oo__ptr = ::new(oo__buf, oo__iobj) AtlasProdEvent(oo__iobj);
	    otmStealVtbls(ooTypeN(AtlasProdEvent), (void *) oo__ptr);
	    delete oo__buf;
	} else {
	    otmSignalInitError("Could not new an object of type AtlasProdEvent");
	}
    } else {
	double oo__buf[(sizeof(AtlasProdEvent) + sizeof(double) - 1)/sizeof(double)];
	ooCPtr(AtlasProdEvent) oo__ptr = ::new(oo__buf, oo__iobj) AtlasProdEvent(oo__iobj);
	otmStealVtbls(ooTypeN(AtlasProdEvent), (void *) oo__ptr);
    }
    if (sizeof(AtlasProdTag) > 1000) {
	double *oo__buf =
	    new double [(sizeof(AtlasProdTag) + sizeof(double) - 1)/sizeof(double)];
	if (oo__buf != 0) {
	    ooCPtr(AtlasProdTag) oo__ptr = ::new(oo__buf, oo__iobj) AtlasProdTag(oo__iobj);
	    otmStealVtbls(ooTypeN(AtlasProdTag), (void *) oo__ptr);
	    delete oo__buf;
	} else {
	    otmSignalInitError("Could not new an object of type AtlasProdTag");
	}
    } else {
	double oo__buf[(sizeof(AtlasProdTag) + sizeof(double) - 1)/sizeof(double)];
	ooCPtr(AtlasProdTag) oo__ptr = ::new(oo__buf, oo__iobj) AtlasProdTag(oo__iobj);
	otmStealVtbls(ooTypeN(AtlasProdTag), (void *) oo__ptr);
    }
}




/* methods on ooHandle(AtlasProdEvent) */
ooHandle(AtlasProdEvent)
ooHandle(AtlasProdEvent)::copy(const ooHandle(ooObj)& nearH) const
{
  ooHandle(AtlasProdEvent) newObjH;
  opiCopyObj(this, nearH, newObjH);
  return newObjH;
}
ooHandle(AtlasProdEvent)&
ooHandle(AtlasProdEvent)::copy(const ooHandle(ooObj)& nearH,
		    ooHandle(AtlasProdEvent)& newObjH) const
{
  opiCopyObj(this, nearH, newObjH);
  return newObjH;
}
ooStatus
ooHandle(AtlasProdEvent)::lookupObj(const ooHandle(ooObj)& scopeH,
			 const ooKey& key,
			 ooMode openMode)
{
  return opiLookupObj(*this, scopeH, key, ooTypeN(AtlasProdEvent), openMode);
}
ooStatus
ooHandle(AtlasProdEvent)::lookupObj(const ooHandle(ooObj)& scopeH,
			 const char* name,
			 ooMode openMode)
{
  return opiLookupObj(*this, scopeH, name, ooTypeN(AtlasProdEvent), openMode);
}


/* methods on ooItr(AtlasProdEvent) */
ooItr(AtlasProdEvent)::~ooItrStructor(AtlasProdEvent)()
{
}
ooItr(AtlasProdEvent)::ooItrStructor(AtlasProdEvent)() :
    _itr(ooTypeN(AtlasProdEvent))
{
}



/* methods on ooRef(AtlasProdEvent) */
ooStatus
ooRef(AtlasProdEvent)::lookupObj(const ooHandle(ooObj)& scopeH,
		      const ooKey& key,
		      ooMode openMode)
{
  ooHandle(AtlasProdEvent) thisH;
  ooStatus status;
  status = opiLookupObj(thisH, scopeH, key, ooTypeN(AtlasProdEvent), openMode);
  *this = thisH;
  return status;
}
ooStatus
ooRef(AtlasProdEvent)::lookupObj(const ooHandle(ooObj)& scopeH,
		      const char* name,
		      ooMode openMode)
{
  ooHandle(AtlasProdEvent) thisH;
  ooStatus status;
  status = opiLookupObj(thisH, scopeH, name, ooTypeN(AtlasProdEvent), openMode);
  *this = thisH;
  return status;
}
// ODMG methods:
ooRef(AtlasProdEvent)::ooRefStructor(AtlasProdEvent)(const d_Ref_Any &from)
{
  opiRefFromAny(ooTypeN(AtlasProdEvent), this, &from);
}
ooTypeNumber
AtlasProdEvent::ooGetTypeN() const
{
  return (ooTypeNumber) ooTypeN(AtlasProdEvent);
}
char*
AtlasProdEvent::ooGetTypeName() const
{
  return "AtlasProdEvent";
}
ooBoolean
AtlasProdEvent::ooIsKindOf(ooTypeNumber typeN) const
{
  return ooTypeN(AtlasProdEvent) == typeN || HepEvent::ooIsKindOf(typeN);
}
ooHandle(AtlasProdEvent)
AtlasProdEvent::ooThis(ooMode aMode) const
{
  ooHandle(AtlasProdEvent) objH;
      opiGetObjHandle(ooDysoc(), objH, aMode);
 return objH;
}
void*
AtlasProdEvent::operator new(size_t size,
		 const ooHandle(ooObj) &nearH)
{
  return opiNewObj(size, ooTypeN(AtlasProdEvent), nearH);
}
void*
AtlasProdEvent::operator new(size_t size, const ooId& nearId)
{
  ooHandle(ooObj) nearH(nearId);
      return opiNewObj(size, ooTypeN(AtlasProdEvent), nearH);
}
void*
AtlasProdEvent::operator new(size_t size, ooConstCPtr(ooObj) nearObj)
{
  return opiNewObj(size, ooTypeN(AtlasProdEvent), nearObj);
}
void *
AtlasProdEvent::operator new(size_t size,
		 const ooHandle(ooObj) &nearH,
		 const char *)
{
  return operator new(size, nearH);
}
// static
void
AtlasProdEvent::ooAssocRegister()
{
}
ooRef(AtlasProdEvent)&
AtlasProdEvent::ooThis(ooRef(AtlasProdEvent)& objId, ooMode aMode) const
{
  ooHandle(AtlasProdEvent) objH;
  opiGetObjHandle(ooDysoc(), objH, aMode);
  objId = objH;
  return objId;
}
AtlasProdEvent::AtlasProdEvent(::ooInternalObj iobj): HepEvent(iobj){}


/* methods on ooHandle(AtlasProdTag) */
ooHandle(AtlasProdTag)
ooHandle(AtlasProdTag)::copy(const ooHandle(ooObj)& nearH) const
{
  ooHandle(AtlasProdTag) newObjH;
  opiCopyObj(this, nearH, newObjH);
  return newObjH;
}
ooHandle(AtlasProdTag)&
ooHandle(AtlasProdTag)::copy(const ooHandle(ooObj)& nearH,
		    ooHandle(AtlasProdTag)& newObjH) const
{
  opiCopyObj(this, nearH, newObjH);
  return newObjH;
}
ooStatus
ooHandle(AtlasProdTag)::lookupObj(const ooHandle(ooObj)& scopeH,
			 const ooKey& key,
			 ooMode openMode)
{
  return opiLookupObj(*this, scopeH, key, ooTypeN(AtlasProdTag), openMode);
}
ooStatus
ooHandle(AtlasProdTag)::lookupObj(const ooHandle(ooObj)& scopeH,
			 const char* name,
			 ooMode openMode)
{
  return opiLookupObj(*this, scopeH, name, ooTypeN(AtlasProdTag), openMode);
}


/* methods on ooItr(AtlasProdTag) */
ooItr(AtlasProdTag)::~ooItrStructor(AtlasProdTag)()
{
}
ooItr(AtlasProdTag)::ooItrStructor(AtlasProdTag)() :
    _itr(ooTypeN(AtlasProdTag))
{
}



/* methods on ooRef(AtlasProdTag) */
ooStatus
ooRef(AtlasProdTag)::lookupObj(const ooHandle(ooObj)& scopeH,
		      const ooKey& key,
		      ooMode openMode)
{
  ooHandle(AtlasProdTag) thisH;
  ooStatus status;
  status = opiLookupObj(thisH, scopeH, key, ooTypeN(AtlasProdTag), openMode);
  *this = thisH;
  return status;
}
ooStatus
ooRef(AtlasProdTag)::lookupObj(const ooHandle(ooObj)& scopeH,
		      const char* name,
		      ooMode openMode)
{
  ooHandle(AtlasProdTag) thisH;
  ooStatus status;
  status = opiLookupObj(thisH, scopeH, name, ooTypeN(AtlasProdTag), openMode);
  *this = thisH;
  return status;
}
// ODMG methods:
ooRef(AtlasProdTag)::ooRefStructor(AtlasProdTag)(const d_Ref_Any &from)
{
  opiRefFromAny(ooTypeN(AtlasProdTag), this, &from);
}
ooTypeNumber
AtlasProdTag::ooGetTypeN() const
{
  return (ooTypeNumber) ooTypeN(AtlasProdTag);
}
char*
AtlasProdTag::ooGetTypeName() const
{
  return "AtlasProdTag";
}
ooBoolean
AtlasProdTag::ooIsKindOf(ooTypeNumber typeN) const
{
  return ooTypeN(AtlasProdTag) == typeN || HepEventTag::ooIsKindOf(typeN);
}
ooHandle(AtlasProdTag)
AtlasProdTag::ooThis(ooMode aMode) const
{
  ooHandle(AtlasProdTag) objH;
      opiGetObjHandle(ooDysoc(), objH, aMode);
 return objH;
}
void*
AtlasProdTag::operator new(size_t size,
		 const ooHandle(ooObj) &nearH)
{
  return opiNewObj(size, ooTypeN(AtlasProdTag), nearH);
}
void*
AtlasProdTag::operator new(size_t size, const ooId& nearId)
{
  ooHandle(ooObj) nearH(nearId);
      return opiNewObj(size, ooTypeN(AtlasProdTag), nearH);
}
void*
AtlasProdTag::operator new(size_t size, ooConstCPtr(ooObj) nearObj)
{
  return opiNewObj(size, ooTypeN(AtlasProdTag), nearObj);
}
void *
AtlasProdTag::operator new(size_t size,
		 const ooHandle(ooObj) &nearH,
		 const char *)
{
  return operator new(size, nearH);
}
// static
void
AtlasProdTag::ooAssocRegister()
{
}
ooRef(AtlasProdTag)&
AtlasProdTag::ooThis(ooRef(AtlasProdTag)& objId, ooMode aMode) const
{
  ooHandle(AtlasProdTag) objH;
  opiGetObjHandle(ooDysoc(), objH, aMode);
  objId = objH;
  return objId;
}
AtlasProdTag::AtlasProdTag(::ooInternalObj iobj): HepEventTag(iobj){}
#if defined(_MSC_VER) && !defined(OO_DDL_TRANSLATION)
#pragma pack(pop)
#endif
